// -------------------------------------------------------------------------
// Copyright @ 1997 TCK Software, Incorporated
// All Rights Reserved
// -------------------------------------------------------------------------
// vfTestView.h : interface of the CVTreeView class
//
/////////////////////////////////////////////////////////////////////////////

#include "testVF.h"
#include "person3VF.h"			// Morphing Tree View
#include "PalHook.h"

class CVTreeView : public CView
{
protected: // create from serialization only
	CPerson2DB	m_personDB;
	CPerson3VF	m_vForm;					// Test Tree form 
	CPalMsgHandler m_palMsgHandler;

	CVTreeView();
	DECLARE_DYNCREATE(CVTreeView)

// Attributes
public:
	CVfTestDoc* GetDocument();
	void ResetPalette();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVTreeView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnInitialUpdate();
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CVTreeView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CVTreeView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnFilePrintScreen();
	afx_msg void OnFilePrintAll();
	afx_msg void OnFilePrintSelected();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in vfTestView.cpp
inline CVfTestDoc* CVTreeView::GetDocument()
   { return (CVfTestDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
