// -------------------------------------------------------------------------
// Copyright @ 1997 TCK Software, Incorporated
// All Rights Reserved
// -------------------------------------------------------------------------

#include "stdafx.h"
#include "person2VF.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Static Data Members

// -------------------------------------------------------------------------
// CPerson2Hdr Constructor
// -------------------------------------------------------------------------
CPerson2Hdr::CPerson2Hdr()
{
	Height(40);

	m_chkSelectors.Init(this, IDVC_CHK_SELECTORS, _T("Selectors"), 5,5,80,20);
	m_lblBackGround.Init(this, -1, _T("Background:"), 100,7,83,20);
	m_lstBgOption.Init(this, IDVC_BG_OPTION, _T("Bitmap"), 185,5,90,20);
	m_btnSetBmp.Init(this, IDVC_SET_BMP, _T("Set Bmp"), 285,5,70,20);
	m_chkShadow.Init(this, IDVC_CHK_SHADOW, _T("Shadow"), 370,5,80,20);
	m_lstBoxStyle.Init(this, IDVC_BOX_STYLE, _T("Shadow"), 370,5,90,20);
	m_nBackStyle = 0;
	m_chkSelectors.Checked(TRUE);
	m_chkShadow.Checked(TRUE);

	m_lstBgOption.AddString(_T("Normal"));
	m_lstBgOption.AddString(_T("Green Bar"));
	m_lstBgOption.AddString(_T("Paper Pad"));
	m_lstBgOption.AddString(_T("Flat Look"));
	m_lstBgOption.AddString(_T("Bitmap"));

	m_lstBoxStyle.AddString(_T("Normal"));
	m_lstBoxStyle.AddString(_T("Shadow"));
	m_lstBoxStyle.AddString(_T("Indented"));
	m_lstBoxStyle.AddString(_T("Bumped"));

	AddCtl(&m_chkSelectors);
	AddCtl(&m_lblBackGround);
	AddCtl(&m_lstBgOption);
	AddCtl(&m_btnSetBmp);
	AddCtl(&m_lstBoxStyle);
}

// -------------------------------------------------------------------------
// CPerson2Ftr Constructor
// -------------------------------------------------------------------------
CPerson2Ftr::CPerson2Ftr()
{
	Height(35);
	m_lblGoodbye.Init(this, -1, _T("Footer:"), 80,5,60,20);
	m_ftrEdit.Init(this, IDVC_FTREDIT, _T("Goodbye"), 150,5,100,20);

	m_ftrEdit.LimitText(20);					// Set max chars for m_ftrEdit

	AddCtl(&m_lblGoodbye);
	AddCtl(&m_ftrEdit);
}


// -------------------------------------------------------------------------
// CPerson2Row Constructor
// -------------------------------------------------------------------------
CPerson2Row::CPerson2Row(CPerson2VF* pVf)
{
	m_recno.Init(this, IDVCMORPH_RECNO,     _T(""), 50,5,20,20);
	m_btnPlus.Init(this, IDVCMORPH_BTNPLUS, _T("+"), 75,3,18,18);
	m_name.Init(this, IDVCMORPH_NAME,       _T(""), 100,3,145,20);
	m_note.Init(this, IDVCMORPH_NOTE,       _T(""), 255,3,250,20);
	m_phoneDesc.Init(this, IDVCMORPH_PHONEDESC,  _T(""), 255,3,90,20);
	m_phone.Init(this, IDVCMORPH_PHONE,      _T(""), 355,3,160,20);

	m_name.LimitText(PERS2_NAME);
	m_note.LimitText(PERS2_NOTE);

	m_phone.LimitText(PERS2_PHONE);
	m_phoneDesc.LimitText(PERS2_PHONEDESC);

	SetIconPosition(5, 0);

	// --- Add a profile for each type of row to display ---
	NewProfile(P2PROFILE_PERSON);
	NewProfile(P2PROFILE_PHONE);

	VMorphProfile *pProfile;

	pProfile = GetProfile(P2PROFILE_PERSON);
	pProfile->AddCtl(&m_recno);
	pProfile->AddCtl(&m_btnPlus);
	pProfile->AddCtl(&m_name);
	pProfile->AddCtl(&m_note);

	pProfile = GetProfile(P2PROFILE_PHONE);
	pProfile->AddCtl(&m_recno);
	pProfile->AddCtl(&m_btnPlus);
	pProfile->AddCtl(&m_name);
	pProfile->AddCtl(&m_phoneDesc);
	pProfile->AddCtl(&m_phone);

	SetProfileIdx(P2PROFILE_PERSON);		// Default

	m_nBackStyle = 0;
	SetForm(pVf);				// We need the form set BEFORE calling SetBG
	SetEffect(VEFFECT_SHADOW);
}

// -------------------------------------------------------------------------
// CPerson2Row Destructor
// -------------------------------------------------------------------------
CPerson2Row::~CPerson2Row()
{
}


// -------------------------------------------------------------------------
// GetBackBmp
// -------------------------------------------------------------------------
HBITMAP CPerson2Row::GetBackBmp()
{
	return ((CPerson2VF*)Form())->GetBackBmp(); 
}

// -------------------------------------------------------------------------
// GetBackPalette
// -------------------------------------------------------------------------
HPALETTE CPerson2Row::GetBackPaletteHandle()
{
	return ((CPerson2VF*)Form())->GetBackPalette(); 
}

// -------------------------------------------------------------------------
// CPerson2Row SetEffect
// -------------------------------------------------------------------------
void CPerson2Row::SetEffect(int nEffect)
{
	int nEffectDepth = (nEffect == VEFFECT_SHADOW) ? 1 : 0;

	m_name.Effect(nEffect);
	m_note.Effect(nEffect);
	m_phoneDesc.Effect(nEffect);
	m_phone.Effect(nEffect);

	m_name.EffectDepth(nEffectDepth);
	m_note.EffectDepth(nEffectDepth);
	m_phoneDesc.EffectDepth(nEffectDepth);
	m_phone.EffectDepth(nEffectDepth);

	SetBG(m_nBackStyle);		// Switch us BACK from the gray (possibly)
}


// -------------------------------------------------------------------------
// CPerson2Row Background Drawing
// -------------------------------------------------------------------------
void CPerson2Row::SetBG(int nBackStyle)
{
	SetStyle(nBackStyle);

	CPerson2VF* pForm = (CPerson2VF *)Form();
	COLORREF clr;
	BOOL bTransparent = FALSE;
	BOOL bNoInactBorder = TRUE;

	// These just look better in light gray
	if(pForm->GetEffect() == VEFFECT_SUNKEN || 
		pForm->GetEffect() == VEFFECT_RAISED)
		clr = RGB(192,192,192);
	else
		clr = RGB(255,255,255);

	ResetCtl(m_name,      bTransparent, bNoInactBorder, clr);
	ResetCtl(m_note,      bTransparent, bNoInactBorder, clr);
	ResetCtl(m_phoneDesc, bTransparent, bNoInactBorder, clr);
	ResetCtl(m_phone,     bTransparent, bNoInactBorder, clr);
}


// IMPLEMENT_DYNCREATE(CPerson2VF, VForm)

BEGIN_MESSAGE_MAP(CPerson2VF, VForm)
	//{{AFX_MSG_MAP(CPerson2VF)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// -------------------------------------------------------------------------
// CPerson2VF Constructor
// -------------------------------------------------------------------------
CPerson2VF::CPerson2VF()
{
	m_pFont = 0;					// use default font
	m_pPalMH = 0;
	m_nBackIdx = 0;
	m_hIcon = AfxGetApp()->LoadIcon(IDI_POINTHAND);
	m_nRowHeight = 25;
	m_nRowWidth = 510;
	m_nRows = 0;
	m_nEffect = VEFFECT_SHADOW;
	
	// ------------- Header and footer with NOTHING in them --------
	// m_nHeaderHeight = 40;		// Test out header
	// m_nFooterHeight = 35;		// Test out footer

	// ------------- Header and footer with Something in them --------
	CPerson2Hdr *pHdr = new CPerson2Hdr();
	SetHeader(pHdr, FALSE);
	// CPerson2Ftr *pFtr = new CPerson2Ftr();
	// SetFooter(pFtr, FALSE);
	
	m_pFont = GetFonts()->GetOrAdd(_T("Arial"), 100);

	if(!m_imgList.Create(IDB_IMG_TEST, 16, 0, RGB(0,255,255)))
		TRACE(_T("CPerson2VF could not create image list\n"));
	// m_imgList.SetBkColor(GetSysColor(COLOR_WINDOW));
	if(!m_imgCycleList.Create(IDB_IMG_CYCLES, 16, 0, RGB(0,255,255)))
		TRACE(_T("CPerson2VF could not create cycle image list\n"));
	if(!m_imgPrintAnim.Create(IDB_IMG_PRINT_ANIM, 16, 0, RGB(0,255,255)))
		TRACE(_T("CPerson2VF could not create print animation image list\n"));

  	m_personDB.FileName(_T("person2.dat"));
  	if(!m_personDB.OpenOrCreate())
  	{
  		MessageBox(_T("Error opening/creating person2.dat"), _T("VForm Demo"),
  			MB_OK | MB_ICONEXCLAMATION);
  	}
  	SetPersonDB(&m_personDB);
}

// -------------------------------------------------------------------------
// CPerson2VF Destructor
// -------------------------------------------------------------------------
CPerson2VF::~CPerson2VF()
{
	// if(m_hBmpBack)	::DeleteObject(m_hBmpBack);
}

void CPerson2VF::SetPersonDB(CPerson2DB *pDB)
{
	m_pPersonDB = pDB;
	int nRecords = m_pPersonDB->GetCount();
	ResetNumRows(nRecords, 0);
}


BOOL CPerson2VF::SetBackBmp(LPCTSTR szFile)
{
	BOOL bRet;

	m_bmpBack.DeleteObject();				// remove old
	bRet = m_bmpBack.LoadFile(szFile);		// load new
	// m_pWnd->ResetPalette();
	m_pPalMH->DoRealizePalette(TRUE);

	return bRet;
}


// -------------------------------------------------------------------------
// Function to create a CPerson2Row
// -------------------------------------------------------------------------
VRow* CPerson2VF::InitRow()
{
	CPerson2Row *pRow = new CPerson2Row(this);
	pRow->SetIcon(m_hIcon);
	return(pRow); 
}

// -------------------------------------------------------------------------
// Called when a row needs to be put on the screen
// -------------------------------------------------------------------------
BOOL CPerson2VF::OnGetRow(VRow *pRow)
{
	CString s1;
	CPerson2Row *r = (CPerson2Row*) pRow;
	long idx;
	CPerson2 data;

	idx = r->RowId();

	if(!m_pPersonDB->GetRec(idx, data))
		return FALSE;

	if(data.IsDeleted())
	{
	 	r->m_recno.Visible(FALSE);
		r->m_name.Visible(FALSE);
		r->m_note.Visible(FALSE);
		r->m_phoneDesc.Visible(FALSE);
		r->m_phone.Visible(FALSE);
	}
	else
	{
	 	r->m_recno.Visible(TRUE);
		r->m_name.Visible(TRUE);
		r->m_note.Visible(TRUE);
		r->m_phoneDesc.Visible(TRUE);
		r->m_phone.Visible(TRUE);
	}

	r->m_bDeleted = data.IsDeleted();

	// s1.Format(_T("%ld:%d"), r->RowId(), r->SRowId());
	s1.Format(_T("%ld"), idx+1);
	r->m_recno.SetWindowText(s1);

	r->m_name.SetWindowText(data.m_name);
	r->m_note.SetWindowText(data.m_note);
	r->m_phoneDesc.SetWindowText(data.m_phones[0].m_phoneDesc);
	r->m_phone.SetWindowText(data.m_phones[0].m_phone);

	return TRUE;
}

// -------------------------------------------------------------------------
// Called when a row needs to be saved (in the data)
// -------------------------------------------------------------------------
BOOL CPerson2VF::OnSaveRow(VRow *pRow)
{
	CPerson2Row *r = (CPerson2Row*) pRow;
	long idx;
	CPerson2    data;

	idx = r->RowId();

	if(data.IsDeleted())
		return FALSE;

	_tcscpy(data.m_name, r->m_name.Text());
	_tcscpy(data.m_note, r->m_note.Text());
	_tcscpy(data.m_phones[0].m_phoneDesc, r->m_phoneDesc.Text());
	_tcscpy(data.m_phones[0].m_phone, r->m_phone.Text());
	data.m_deleted = 'N';

	if(!m_pPersonDB->UpdateRec(idx, data))
		return FALSE;

	return TRUE;
}

// -------------------------------------------------------------------------
// Called when row(s) needs to be deleted from the data
// -------------------------------------------------------------------------
BOOL CPerson2VF::OnDelete()
{
	CString s1;
	long nNumSelected = m_selectedList.Count();

	s1.Format(
		_T("You have selected to delete %ld records\nActual delete not enabled in this demo"),
		nNumSelected);
	AfxMessageBox(s1);
	return TRUE;				// Dont let delete key pass through
}

// -------------------------------------------------------------------------
// Called when a row needs to be added to the data
// -------------------------------------------------------------------------
BOOL CPerson2VF::OnAddRow(VRow *pRow)
{
	CPerson2Row *r = (CPerson2Row*) pRow;
	int idx;
	CPerson2    data;

	idx = r->RowId();

	_tcscpy(data.m_name, r->m_name.Text());
	_tcscpy(data.m_note, r->m_note.Text());
	_tcscpy(data.m_phones[0].m_phoneDesc, r->m_phoneDesc.Text());
	_tcscpy(data.m_phones[0].m_phone, r->m_phone.Text());
	data.m_deleted = 'N';

	if(!m_pPersonDB->AddRec(idx, data))
		return FALSE;

	return TRUE;
}

// -------------------------------------------------------------------------
// Called when a row is initially being added
// -------------------------------------------------------------------------
void CPerson2VF::OnStartAdd(VRow *pRow)
{
	CString s1;
	CPerson2Row *r = (CPerson2Row*) pRow;
	long idx;
	// CPerson2   data;

	idx = r->RowId();
	
	s1.Format(_T("%ld"), idx+1);
	r->m_recno.SetWindowText(s1);

	r->m_name.SetWindowText(_T(""));
	r->m_note.SetWindowText(_T(""));
	r->m_phoneDesc.SetWindowText(_T(""));
	r->m_phone.SetWindowText(_T(""));
}


// -------------------------------------------------------------------------
// Called when a button is clicked
// -------------------------------------------------------------------------
void CPerson2VF::OnClick(VRow *pRow, int nId)
{
	CString s1, sBmpFile;
	CPerson2Row *pPersonRow = (CPerson2Row*) pRow;
	static _TCHAR szFilter[] = _T("Bitmaps (*.bmp)|*.bmp|All Files (*.*)|*.*||"); 

	switch(nId)
	{
	case IDVC_CHK_SELECTORS:
		{
			CPerson2Hdr *pHdr = (CPerson2Hdr *)Header();
			if(pHdr->m_chkSelectors.Checked())
				UseSelectors(TRUE);
			else
				UseSelectors(FALSE);
			break;
		}	
	case IDVCMORPH_BTNPLUS:
		{
			int nProfIdx = pPersonRow->GetProfileIdx();
			if(nProfIdx == P2PROFILE_PERSON)
			{
				pPersonRow->SetProfileIdx(P2PROFILE_PHONE);
				pPersonRow->m_btnPlus.Text(_T("-"));
			}
			else
			{
				pPersonRow->SetProfileIdx(P2PROFILE_PERSON);
				pPersonRow->m_btnPlus.Text(_T("+"));
			}
			pPersonRow->Draw();		// Redraw
			break;
		}
	case IDVC_SET_BMP:
		{
			CFileDialog dlg(TRUE, _T("bmp"), sBmpFile, 
				OFN_SHAREAWARE | OFN_PATHMUSTEXIST, szFilter); 
			if(dlg.DoModal() != IDOK)
				break;

			sBmpFile = dlg.GetPathName();
			if(SetBackBmp(sBmpFile) && m_nBackIdx == 4)
			{
				RefreshScreen(VFR_BOTH);
			}
			break;
		}
	}
}

// -------------------------------------------------------------------------
// Called when list is closed is clicked
// -------------------------------------------------------------------------
BOOL CPerson2VF::OnEndList(VCtl* pCtl, CListBox* pLB)
{
	CPerson2Row *pRow;
	CPerson2Hdr *pHdr;
	int i;
	int nBgStyle = VROW_BG_DEFAULT;

	switch(pCtl->Id())
	{
	case IDVC_BG_OPTION:
		m_nBackIdx = pLB->GetCurSel();

		switch(m_nBackIdx)
		{
		case 0:	nBgStyle = VROW_BG_DEFAULT;		break;
		case 1:	nBgStyle = VROW_BG_GREENBAR;	break;
		case 2:	nBgStyle = VROW_BG_PAPER;		break;
		case 3:	nBgStyle = VROW_BG_FLAT;		break;
		case 4:	nBgStyle = VROW_BG_BMP;			break;
		}

		// Reset detail rows to this style
		pHdr = (CPerson2Hdr *)Header();
		pHdr->SetStyle(nBgStyle);

		pRow = (CPerson2Row *)m_pDtlRow;
		pRow->SetBG(nBgStyle);
		pRow = (CPerson2Row *)m_pTmpRow;
		pRow->SetBG(nBgStyle);

		RefreshScreen(VFR_BOTH);
		break;
	case IDVC_BOX_STYLE:
		i = pLB->GetCurSel();

		switch(i)
		{
		case 0:		m_nEffect = VEFFECT_NORMAL;		break;
		case 1:		m_nEffect = VEFFECT_SHADOW;		break;
		case 2:		m_nEffect = VEFFECT_SUNKEN;		break;
		case 3:		m_nEffect = VEFFECT_RAISED;		break;
		default:	m_nEffect = VEFFECT_NORMAL;		break;
		}

		// Reset detail rows to this style
		pRow = (CPerson2Row *)m_pDtlRow;
		pRow->SetEffect(m_nEffect);
		pRow = (CPerson2Row *)m_pTmpRow;
		pRow->SetEffect(m_nEffect);

		RefreshScreen(VFR_BOTH);
	}
	return TRUE;
}


// -------------------------------------------------------------------------
//	Start a timer for the form
// -------------------------------------------------------------------------
int CPerson2VF::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (VForm::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// m_nTimerId = SetTimer(ANIM_TIMER, 300, NULL);
	// if(m_nTimerId == 0)
	// {
	//	TRACE(_T("CPerson2VF::OnCreate - Unable to SetTimer\n"));
	// }

	return 0;
}

