// -------------------------------------------------------------------------
// Copyright @ 1997 TCK Software, Incorporated
// All Rights Reserved
// -------------------------------------------------------------------------
#ifndef __PERSON2VF_H__
#define __PERSON2VF_H__

#include "vForm.h"
#include "vRowMorph.h"

#include "VCtl2.h"
#include "person2.h"

#include "VBitmap.h"
#include "PalHook.h"

#define IDVCMORPH_RECNO			201
#define IDVCMORPH_BTNPLUS		202
#define IDVCMORPH_NAME			203
#define IDVCMORPH_NOTE			204

#define IDVCMORPH_PHONEDESC		205
#define IDVCMORPH_PHONE			206

#define IDVC_HDREDIT		240
#define IDVC_BG_OPTION		241
#define IDVC_SET_BMP		242
#define IDVC_CHK_SHADOW		243
#define IDVC_BOX_STYLE		244
#define IDVC_CHK_SELECTORS	245
#define IDVC_FTREDIT		250

#define P2PROFILE_PERSON	0
#define P2PROFILE_PHONE		1

class CPerson2VF;
class CVfTestView;

// -------------------------------------------------------------------------
// CPerson2Hdr Class
// -------------------------------------------------------------------------
class CPerson2Hdr : public VHeader
{
public:
	CPerson2Hdr();
	virtual ~CPerson2Hdr() {};

public:
	VCheckBox	m_chkSelectors;
	VStatic		m_lblBackGround;
	VDropDown	m_lstBgOption;
	VDropDown	m_lstBoxStyle;
	VEdit		m_hdrEdit;
	VButton		m_btnSetBmp;
	VCheckBox	m_chkShadow;
};

// -------------------------------------------------------------------------
// CPerson2Ftr Class
// -------------------------------------------------------------------------
class CPerson2Ftr : public VHeader
{
public:
	CPerson2Ftr();
	virtual ~CPerson2Ftr() {};

public:
	VStatic		m_lblGoodbye;
	VEdit		m_ftrEdit;
};


// -------------------------------------------------------------------------
// CPerson2Row Class
// -------------------------------------------------------------------------
class CPerson2Row : public VRowMorph
{
public:
	CPerson2Row(CPerson2VF* pVf);
	virtual ~CPerson2Row();

	void	SetBG(int nBackStyle);
	void	SetEffect(int nEffect);
	virtual HBITMAP		GetBackBmp();
	virtual HPALETTE	GetBackPaletteHandle();

public:
	VStatic		m_recno;
	VButton		m_btnPlus;
	VEdit		m_name;
	VEdit		m_note;
	VEdit		m_phoneDesc;
	VEdit		m_phone;
	BOOL		m_bDeleted;
};


// -------------------------------------------------------------------------
// CPerson2VF Class - Morphing Rows
// -------------------------------------------------------------------------
class CPerson2VF : public VForm
{
public:
	CPerson2DB	*m_pPersonDB;
	CPerson2DB   m_personDB;
	CPalMsgHandler*	m_pPalMH;
protected:
	CImageList	m_imgList;		// Image list for picture control
	CImageList	m_imgCycleList;	// Image list for picture control
	CImageList	m_imgPrintAnim;	// Image list for printer animation
	int			m_nBackIdx;		// Background Type
	int			m_nEffect;		// Effect
	HICON		m_hIcon;		// Icon Handle
	UINT		m_nTimerId;		// Animation Timer

	VBitmap	m_bmpBack;			// BMP class

public:
	CPerson2VF();				// Constructor
	virtual ~CPerson2VF();		// Destructor

	CImageList* GetTestImgList()	{ return &m_imgList; }
	CImageList* GetCycleImgList()	{ return &m_imgCycleList; }
	CImageList* GetPrintAnimImg()	{ return &m_imgPrintAnim; }
	VBitmap*	GetBmp()			{ return &m_bmpBack; }
	HBITMAP		GetBackBmp()		{ return m_bmpBack; }
	HPALETTE	GetBackPalette()	{ return m_bmpBack.GetPaletteHandle(); }
	CPalette*	GetPalette()		{ return m_bmpBack.GetPalette(); }
	int			GetEffect()			{ return m_nEffect; }

	void		SetPersonDB(CPerson2DB *pDB);
	BOOL		SetBackBmp(LPCTSTR szFile);		// Set the background BMP
	void		SetPalMH(CPalMsgHandler *pPalMH)	{ m_pPalMH = pPalMH; }

	// DECLARE_DYNCREATE(CPerson2VF)

// Operations
public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPerson2VF)
	public:
	protected:
	//}}AFX_VIRTUAL

protected:
	virtual VRow*	InitRow();

	// --- the following functions deal with the Data ---
	virtual	BOOL	OnGetRow(VRow *pRow);		// Gets row for screen
	virtual BOOL	OnSaveRow(VRow *pRow);		// Save row from screen
	virtual BOOL	OnAddRow(VRow *pRow);		// Add a data row
	virtual BOOL	OnDelete();					// Delete row(s)
	virtual void	OnStartAdd(VRow *pRow);		// Start of Add: Defaults

	virtual void	OnClick(VRow *pRow, int nId);
	virtual BOOL	OnEndList(VCtl* pCtl, CListBox* pLB);

// Generated message map functions
protected:
	//{{AFX_MSG(CPerson2VF)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

#endif
