// -------------------------------------------------------------------------
// Copyright @ 1997 TCK Software, Incorporated
// All Rights Reserved
// -------------------------------------------------------------------------
#ifndef __PERSON3VF_H__
#define __PERSON3VF_H__

#include "vForm.h"
#include "vTree.h"
#include "vRowMorph.h"

#include "VCtl2.h"
#include "person2.h"
#include "VTree.h"

#include "VBitmap.h"
#include "PalHook.h"

#define IDVCTREE_RECNO			201
#define IDVCTREE_BTNPLUS		202
#define IDVCTREE_NAME			203
#define IDVCTREE_NOTE			204

#define IDVCTREE_PHONEDESC		205
#define IDVCTREE_PHONE			206

#define IDVC_HDREDIT		240
#define IDVC_BG_OPTION		241
#define IDVC_SET_BMP		242
#define IDVC_CHK_SHADOW		243
#define IDVC_BOX_STYLE		244
#define IDVC_CHK_SELECTORS	245
#define IDVC_FTREDIT		250

#define P2PROFILE_PERSON	0
#define P2PROFILE_PHONE		1

class CPerson3VF;
class CVfTestView;

class VTIPerson : public VTreeItem
{
public:
	VTIPerson();

	long		m_nRecNo;		// Id of data record
	_TCHAR		m_name[PERS2_NAME+1];
	_TCHAR		m_note[PERS2_NOTE+1];
	int			m_nPhoneCnt;

	int			IsA()	{ return P2PROFILE_PERSON; }
};

class VTIPersonPhone : public VTreeItem
{
public:
	VTIPersonPhone();

	long		m_nRecNo;		// Id of data record
	short		m_nPhoneIdx;	// Idx of phone rec
	_TCHAR		m_phoneDesc[PERS2_PHONEDESC+1];
	_TCHAR		m_phone[PERS2_PHONE+1];

	int			IsA()	{ return P2PROFILE_PHONE; }
};


// -------------------------------------------------------------------------
// CPerson3Hdr Class
// -------------------------------------------------------------------------
class CPerson3Hdr : public VHeader
{
public:
	CPerson3Hdr();
	virtual ~CPerson3Hdr() {};

public:
	VCheckBox	m_chkSelectors;
	VStatic		m_lblBackGround;
	VDropDown	m_lstBgOption;
	VDropDown	m_lstBoxStyle;
	VEdit		m_hdrEdit;
	VButton		m_btnSetBmp;
	VCheckBox	m_chkShadow;
};

// -------------------------------------------------------------------------
// CPerson3Ftr Class
// -------------------------------------------------------------------------
class CPerson3Ftr : public VHeader
{
public:
	CPerson3Ftr();
	virtual ~CPerson3Ftr() {};

public:
	VStatic		m_lblGoodbye;
	VEdit		m_ftrEdit;
};


// -------------------------------------------------------------------------
// CPerson3Row Class
// -------------------------------------------------------------------------
class CPerson3Row : public VRowMorph
{
public:
	CPerson3Row(CPerson3VF* pVf);
	virtual ~CPerson3Row();

	void	SetBG(int nBackStyle);
	void	SetEffect(int nEffect);
	virtual HBITMAP		GetBackBmp();
	virtual HPALETTE	GetBackPaletteHandle();

public:
	VStatic		m_recno;
	VButton		m_btnPlus;
	VEdit		m_name;
	VEdit		m_note;
	VEdit		m_phoneDesc;
	VEdit		m_phone;
	BOOL		m_bDeleted;
};


// -------------------------------------------------------------------------
// CPerson3VF Class
// -------------------------------------------------------------------------
class CPerson3VF : public VForm
{
public:
	CPerson2DB	*m_pPersonDB;
	CPerson2DB  m_personDB;
	VTree		m_tree;			// The Tree
	CPalMsgHandler*	m_pPalMH;
protected:
	CImageList	m_imgList;		// Image list for picture control
	CImageList	m_imgCycleList;	// Image list for picture control
	CImageList	m_imgPrintAnim;	// Image list for printer animation
	int			m_nBackIdx;		// Background Type
	int			m_nEffect;		// Effect
	HICON		m_hIcon;		// Icon Handle
	UINT		m_nTimerId;		// Animation Timer

	VBitmap		m_bmpBack;		// BMP class

public:
	CPerson3VF();				// Constructor
	virtual ~CPerson3VF();		// Destructor

	CImageList* GetTestImgList()	{ return &m_imgList; }
	CImageList* GetCycleImgList()	{ return &m_imgCycleList; }
	CImageList* GetPrintAnimImg()	{ return &m_imgPrintAnim; }
	VBitmap*	GetBmp()			{ return &m_bmpBack; }
	HBITMAP		GetBackBmp()		{ return m_bmpBack; }
	HPALETTE	GetBackPalette()	{ return m_bmpBack.GetPaletteHandle(); }
	CPalette*	GetPalette()		{ return m_bmpBack.GetPalette(); }
	int			GetEffect()			{ return m_nEffect; }

	void		SetPersonDB(CPerson2DB *pDB);
	BOOL		SetBackBmp(LPCTSTR szFile);		// Set the background BMP
	void		SetPalMH(CPalMsgHandler *pPalMH)	{ m_pPalMH = pPalMH; }

	// Callback function for sorting of tree elements
	static int SortFunc(VTreeItem **, VTreeItem **);

	// DECLARE_DYNCREATE(CPerson3VF)

// Operations
public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPerson3VF)
	public:
	protected:
	//}}AFX_VIRTUAL

protected:
	virtual VRow*	InitRow();

	// --- the following functions deal with the Data ---
	virtual	BOOL	OnGetRow(VRow *pRow);		// Gets row for screen
	virtual BOOL	OnSaveRow(VRow *pRow);		// Save row from screen
	virtual BOOL	OnAddRow(VRow *pRow);		// Add a data row
	virtual BOOL	OnDelete();					// Delete row(s)
	virtual void	OnStartAdd(VRow *pRow);		// Start of Add: Defaults

	virtual void	OnClick(VRow *pRow, int nId);
	virtual BOOL	OnEndList(VCtl* pCtl, CListBox* pLB);

// Generated message map functions
protected:
	//{{AFX_MSG(CPerson3VF)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

#endif
