// -------------------------------------------------------------------------
// Copyright @ 1997 TCK Software, Incorporated
// All Rights Reserved
// -------------------------------------------------------------------------
#ifndef __PERSONVF_H__
#define __PERSONVF_H__

#include "vForm.h"

#include "VCtl2.h"
#include "VCtlOle.h"
#include "person.h"

#include "VBitmap.h"
#include "PalHook.h"

#define IDVC_RECNO			201
#define IDVC_NAME			202
#define IDVC_ADDRESS		203
#define IDVC_CITY			203
#define IDVC_STATE			204
#define IDVC_ZIP			205
#define IDVC_PHONE			206
#define IDVC_FRIENDCHECK	207
#define IDVC_TESTBUTTON		208

#define IDVC_HDREDIT			240
#define IDVC_BG_OPTION			241
#define IDVC_SET_BMP			242
#define IDVC_CHK_SHADOW			243
#define IDVC_BOX_STYLE			244
#define IDVC_CHK_SELECTORS		245
#define IDVC_RDO_INACTBORDER	246
#define IDVC_CHK_TRANSPARENT	247
#define IDVC_FTREDIT			250
#define IDVC_CHK_GRID_MODE		251
#define IDVC_LST_GRID_STYLE		252
#define IDVC_CHK_LIVE_RESIZING	253
#define IDVC_CHK_SNAP_RESIZE	254

class CPersonVF;
class CVfTestView;

// -------------------------------------------------------------------------
// CPersonRptHdr Class
// -------------------------------------------------------------------------
class CPersonRptHdr : public VRow
{
public:
	CPersonRptHdr();
	VStatic		m_rptHeading;
	VLine		m_line;
};

// -------------------------------------------------------------------------
// CPersonRptFtr Class
// -------------------------------------------------------------------------
class CPersonRptFtr : public VRow
{
public:
	CPersonRptFtr();
	VLine		m_line;
	VStatic		m_rptFooter;
	VStatic		m_rptPageNo;
};

// -------------------------------------------------------------------------
// CPersonRptDtl Class
// -------------------------------------------------------------------------
class CPersonRptDtl : public VRow
{
public:
	CPersonRptDtl();

	VStatic		m_name;
	VStatic		m_address;
	VStatic		m_city;
	VStatic		m_state;
	VStatic		m_zip;
	VStatic		m_phone;
	VCheckBox	m_chkFriend;
};


// -------------------------------------------------------------------------
// CPersonHdr Class
// -------------------------------------------------------------------------
class CPersonHdr : public VHeader
{
public:
	CPersonHdr();

public:
	VCheckBox   m_chkSelectors;
	VStatic		m_lblBackGround;
	VDropDown	m_lstBgOption;
	VDropDown	m_lstBoxStyle;
	VEdit		m_hdrEdit;
	VButton		m_btnSetBmp;
	VCheckBox	m_chkShadow;
	VRadioList	m_rdoInactBorder;
	VCheckBox	m_chkTransparent;
};

// -------------------------------------------------------------------------
// CPersonFtr Class
// -------------------------------------------------------------------------
class CPersonFtr : public VHeader
{
public:
	CPersonFtr();

public:
	VCheckBox	m_chkGridMode;
	VStatic		m_lblGridStyle;
	VDropDown	m_lstGridStyle;
	// VCombo		m_lstGridStyle;
	VCheckBox	m_chkLiveResizing;
	VCheckBox	m_chkSnapResize;
};

// -------------------------------------------------------------------------
// CPersonRow Class
// -------------------------------------------------------------------------
class CPersonRow : public VRow
{
public:
	CPersonRow(CPersonVF* pForm);

	void	SetBG(int nBackStyle);
	void	SetNoInactBorder(BOOL bFlag);
	void	SetTransparent(BOOL bFlag);
	void	SetEffect(int nEffect);
	virtual HBITMAP		GetBackBmp();
	virtual HPALETTE	GetBackPaletteHandle();

public:
	VStatic		m_recno;
	VEdit		m_name;
	VEdit		m_address;
	VEdit		m_city;
	VEdit		m_state;
	VEdit		m_zip;
	VEdit		m_phone;
	VCheckBox	m_chkFriend;
	VButton		m_btnTest;
	BOOL		m_bDeleted;
};


// -------------------------------------------------------------------------
// CPersonVF Class
// -------------------------------------------------------------------------
class CPersonVF : public VForm
{
public:
	CPersonRptHdr	m_rptHdr;
	CPersonRptDtl	m_rptDtl;
	CPersonRptFtr	m_rptFtr;

	CPersonDB	*m_pPersonDB;
	CPersonDB   m_personDB;
	CPalMsgHandler*	m_pPalMH;
protected:
	CImageList	m_imgList;		// Image list for picture control
	CImageList	m_imgCycleList;	// Image list for picture control
	CImageList	m_imgPrintAnim;	// Image list for printer animation
	int			m_nBackIdx;		// Background Type
	int			m_nEffect;		// Effect
	HICON		m_hIcon;		// Icon Handle
	UINT		m_nTimerId;		// Animation Timer

	VBitmap		m_bmpBack;		// BMP class

public:
	CPersonVF();				// Constructor
	virtual ~CPersonVF();		// Destructor

	CImageList* GetTestImgList()	{ return &m_imgList; }
	CImageList* GetCycleImgList()	{ return &m_imgCycleList; }
	CImageList* GetPrintAnimImg()	{ return &m_imgPrintAnim; }
	VBitmap*	GetBmp()			{ return &m_bmpBack; }
	HBITMAP		GetBackBmp()		{ return m_bmpBack; }
	HPALETTE	GetBackPalette()	{ return m_bmpBack.GetPaletteHandle(); }
	CPalette*	GetPalette()		{ return m_bmpBack.GetPalette(); }
	int			GetEffect()			{ return m_nEffect; }

	void		SetPersonDB(CPersonDB *pDB);
	BOOL		SetBackBmp(LPCTSTR szFile);		// Set the background BMP
	void		SetPalMH(CPalMsgHandler *pPalMH)	{ m_pPalMH = pPalMH; }

	// DECLARE_DYNCREATE(CPersonVF)

// Operations
public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPersonVF)
	public:
	protected:
	//}}AFX_VIRTUAL

protected:
	virtual VRow*	InitRow();

	// --- the following functions deal with the Data ---
	virtual	BOOL	OnGetRow(VRow *pRow);		// Gets row for screen
	virtual	BOOL	OnGetRptRow(VRow *pRow);	// Gets row for report
	virtual BOOL	OnSaveRow(VRow *pRow);		// Save row from screen
	virtual BOOL	OnAddRow(VRow *pRow);		// Add a data row
	virtual BOOL	OnDelete();					// Delete row(s)
	virtual void	OnStartAdd(VRow *pRow);		// Start of Add: Defaults

	virtual void	OnClick(VRow *pRow, int nId);
	virtual BOOL	OnBeginDrag(long nRowId);	// Use as a Drag Source
	virtual BOOL	OnDrop(long nRowId,
						COleDataObject* pDataObject, DROPEFFECT dropEffect);
	virtual BOOL	OnEndList(VCtl* pCtl, CListBox* pLB);
	virtual BOOL	OnGridRowColor(VRow *pRow, COLORREF &clrRow);
	virtual BOOL	OnDblClkRow(long nRowId, UINT nFlags, CPoint point);
	virtual BOOL	OnDblClkHeader(UINT nFlags, CPoint point);
	virtual BOOL	OnDblClkDetail(UINT nFlags, CPoint point);
	virtual BOOL	OnDblClkFooter(UINT nFlags, CPoint point);

// Generated message map functions
protected:
	//{{AFX_MSG(CPersonVF)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

#endif
