// -------------------------------------------------------------------------
// Copyright @ 1997 TCK Software, Incorporated
// All Rights Reserved
// -------------------------------------------------------------------------
#ifndef __PICTVF_H__
#define __PICTVF_H__

#include "vForm.h"
#include "VCtl2.h"

#define IDPVF_NAME			201
#define IDPVF_PHONE			202
#define IDPVF_ADDR1			203
#define IDPVF_ADDR2			204
#define IDPVF_CITY			205
#define IDPVF_STATE			206
#define IDPVF_ZIP			207
#define IDPVF_NOTE			208

#define ID_PVF_PICTBTN1		240
#define ID_PVF_PICTBTN2		241
#define ID_PVF_PICTBTN3		242
#define ID_PVF_PICTBTN4		243
#define ID_PVF_PICTBTN5		244
#define ID_PVF_PICTBTN6		245
#define ID_PVF_PICTBTN7		246
#define ID_PVF_ANIM1		247
#define ID_PVF_CYCLE1		248
#define ID_PVF_ANIM2		249
#define ID_PVF_CYCLE2		250

class CPictVf;

// -------------------------------------------------------------------------
// CPictHdr Class
// -------------------------------------------------------------------------
class CPictHdr : public VHeader
{
public:
	CPictHdr(CPictVf* pForm);
	virtual ~CPictHdr() {};

public:
	VPictButton	m_pictBtn1;
	VPictButton	m_pictBtn2;
	VPictButton	m_pictBtn3;
	VPictButton	m_pictBtn4;
	VPictButton	m_pictBtn5;
	VPictButton	m_pictBtn6;
	VPictButton	m_pictBtn7;
	VPicture	m_anim1;
	VPictCycle	m_cycle1;
	VPictCycle	m_cycle2;
	VStatic		m_hdrText;
	VPictCycle	m_pictCycle1;
	VPicture	m_anim2;
};

// -------------------------------------------------------------------------
// CPictRow Class
// -------------------------------------------------------------------------
class CPictRow : public VRow
{
public:
	CPictRow();
	virtual ~CPictRow() {};

public:
	VStatic		m_nameLbl;
	VEdit		m_name;
	VStatic		m_phoneLbl;
	VEdit		m_phone;
	VStatic		m_addr1Lbl;
	VEdit		m_addr1;
	VStatic		m_addr2Lbl;
	VEdit		m_addr2;
	VStatic		m_cityLbl;
	VEdit		m_city;
	VStatic		m_stateLbl;
	VEdit		m_state;
	VStatic		m_zipLbl;
	VEdit		m_zip;
	VEdit		m_note;
};


// -------------------------------------------------------------------------
// CPictData Class
// -------------------------------------------------------------------------
class CPictData
{
public:
	CPictData();

public:
	CString		m_name;
	CString		m_phone;
	CString		m_addr1;
	CString		m_addr2;
	CString		m_city;
	CString		m_state;
	CString		m_zip;
	CString		m_note;
};

// -------------------------------------------------------------------------
// CPictVf Class
// -------------------------------------------------------------------------
class CPictVf : public VForm
{
public:
	CPictData	m_data[100];		// Array of test data
protected:
	CImageList	m_imgBtnList;		// Image list for buttons
	CImageList	m_imgCycleList;		// Image list for picture control
	CImageList	m_imgPrintAnim;		// Image list for printer animation
	CImageList	m_imgSwitch;		// Image list for switch
	CImageList	m_imgSolodexAnim;	// Image list for solodex animation
	CImageList	m_imgLightedBtn;	// Image list for lighted button
	UINT		m_nTimerId;			// Animation Timer

public:
	CPictVf();						// Constructor
	virtual ~CPictVf() {};			// Destructor

	CImageList* GetBtnImgList()		{ return &m_imgBtnList; }
	CImageList* GetCycleImgList()	{ return &m_imgCycleList; }
	CImageList* GetPrintAnimImg()	{ return &m_imgPrintAnim; }
	CImageList* GetSwitchImg()		{ return &m_imgSwitch; }
	CImageList* GetLightedBtnImg()	{ return &m_imgLightedBtn; }
	CImageList* GetSolodexAnimImg()	{ return &m_imgSolodexAnim; }

	// DECLARE_DYNCREATE(CPictVf)

// Operations
public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPictVf)
	public:
	protected:
	//}}AFX_VIRTUAL

protected:
	virtual VRow*	InitRow();

	// --- the following functions deal with the Data ---
	virtual	BOOL	OnGetRow(VRow *pRow);		// Puts row to screen
	virtual BOOL	OnSaveRow(VRow *pRow);		// Save row from screen
	virtual BOOL	OnAddRow(VRow *pRow);		// Add a data row
	virtual void	OnStartAdd(VRow *pRow);		// Start adding a row
	virtual BOOL	OnDelete();					// Delete Rows

	virtual void	OnClick(VRow *pRow, int nId);

// Generated message map functions
protected:
	//{{AFX_MSG(CPictVf)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

#endif
