// -------------------------------------------------------------------------
// Copyright @ 1997 TCK Software, Incorporated
// All Rights Reserved
// -------------------------------------------------------------------------
// vfTest.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "vfTest.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "vfTestDoc.h"
#include "vfTestView.h"
#include "PersonView.h"
#include "MorphView.h"
#include "VTreeView.h"
#include "vfPictView.h"

#include "Example1Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVfTestApp

BEGIN_MESSAGE_MAP(CVfTestApp, CWinApp)
	//{{AFX_MSG_MAP(CVfTestApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_EXAMPLES_DIALOGEXAMPLE, OnExamplesDialogexample)
	ON_COMMAND(ID_EXAMPLES_TEST, OnExamplesTest)
	ON_COMMAND(ID_EXAMPLES_PERSON, OnExamplesPerson)
	ON_COMMAND(ID_EXAMPLES_MORPH, OnExamplesMorph)
	ON_COMMAND(ID_EXAMPLES_TREE, OnExamplesTree)
	ON_COMMAND(ID_EXAMPLES_PICT, OnExamplesPict)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVfTestApp construction

CVfTestApp::CVfTestApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CVfTestApp object

CVfTestApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CVfTestApp initialization

BOOL CVfTestApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.


	// Initialize OLE libraries
	if(!AfxOleInit())
	{
		AfxMessageBox(_T("OLE Initialization Failed"));
		return FALSE;
	}

	AfxEnableControlContainer();

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	LoadStdProfileSettings();	// Load standard INI file options (including MRU)

	VFormRegistrar vfReg;		// Registers the VForm window class
								// NOTE: this is automatically done if you
								// call VForm::Create

	SetRegistryKey(_T("TCK Software"));

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	m_pMdtTest = new CMultiDocTemplate(
		IDR_VFTESTTYPE,
		RUNTIME_CLASS(CVfTestDoc),
		RUNTIME_CLASS(CChildFrame),    // custom MDI child frame
		RUNTIME_CLASS(CVfTestView));
	AddDocTemplate(m_pMdtTest);

	m_pMdtPerson = new CMultiDocTemplate(
		IDR_DATABASETYPE,
		RUNTIME_CLASS(CVfTestDoc),
		RUNTIME_CLASS(CChildFrame),    // custom MDI child frame
		RUNTIME_CLASS(CPersonView));
	AddDocTemplate(m_pMdtPerson);

	m_pMdtMorph = new CMultiDocTemplate(
		IDR_MORPHTYPE,
		RUNTIME_CLASS(CVfTestDoc),
		RUNTIME_CLASS(CChildFrame),    // custom MDI child frame
		RUNTIME_CLASS(CMorphView));
	AddDocTemplate(m_pMdtMorph);

	m_pMdtVTree = new CMultiDocTemplate(
		IDR_VTREETYPE,
		RUNTIME_CLASS(CVfTestDoc),
		RUNTIME_CLASS(CChildFrame),    // custom MDI child frame
		RUNTIME_CLASS(CVTreeView));
	AddDocTemplate(m_pMdtVTree);

	m_pMdtPicture = new CMultiDocTemplate(
		IDR_PICTTYPE,
		RUNTIME_CLASS(CVfTestDoc),
		RUNTIME_CLASS(CChildFrame),    // custom MDI child frame
		RUNTIME_CLASS(CVfPictView));
	AddDocTemplate(m_pMdtPicture);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	// if (!ProcessShellCommand(cmdInfo))
	// 	return FALSE;

	// The main window has been initialized, so show and update it.
	//pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->ShowWindow(SW_SHOWMAXIMIZED);
	pMainFrame->UpdateWindow();

	OnExamplesPerson();			// Display first window

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CVfTestApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CVfTestApp commands

void CVfTestApp::OnExamplesDialogexample() 
{
	CExample1Dlg dlg;

	dlg.DoModal();
}

void CVfTestApp::OnExamplesTest() 
{
	CVfTestDoc *pDoc;

	POSITION posDoc = m_pMdtTest->GetFirstDocPosition();
	if(posDoc)
	{
		pDoc = (CVfTestDoc*) m_pMdtTest->GetNextDoc(posDoc);
		POSITION posView = pDoc->GetFirstViewPosition();
		CView* pView = (CView*) pDoc->GetNextView(posView);
		pView->GetParentFrame()->ActivateFrame(SW_RESTORE);	// Activate View
		return;
	}

	// Make a new window
	pDoc = (CVfTestDoc*) m_pMdtTest->OpenDocumentFile(NULL);
	pDoc->SetTitle(_T("Basic Example"));
}

void CVfTestApp::OnExamplesPerson() 
{
	CVfTestDoc *pDoc;

	POSITION posDoc = m_pMdtPerson->GetFirstDocPosition();
	if(posDoc)
	{
		pDoc = (CVfTestDoc*) m_pMdtPerson->GetNextDoc(posDoc);
		POSITION posView = pDoc->GetFirstViewPosition();
		CView* pView = (CView*) pDoc->GetNextView(posView);
		pView->GetParentFrame()->ActivateFrame(SW_RESTORE);	// Activate View
		return;
	}

	// Make a new window
	pDoc = (CVfTestDoc*) m_pMdtPerson->OpenDocumentFile(NULL);
	pDoc->SetTitle(_T("Person Database Example"));
}

void CVfTestApp::OnExamplesMorph() 
{
	CVfTestDoc *pDoc;

	POSITION posDoc = m_pMdtMorph->GetFirstDocPosition();
	if(posDoc)
	{
		pDoc = (CVfTestDoc*) m_pMdtMorph->GetNextDoc(posDoc);
		POSITION posView = pDoc->GetFirstViewPosition();
		CView* pView = (CView*) pDoc->GetNextView(posView);
		pView->GetParentFrame()->ActivateFrame(SW_RESTORE);	// Activate View
		return;
	}

	// Make a new window
	pDoc = (CVfTestDoc*) m_pMdtMorph->OpenDocumentFile(NULL);
	pDoc->SetTitle(_T("Morphing Example"));
}

void CVfTestApp::OnExamplesTree() 
{
	CVfTestDoc *pDoc;

	POSITION posDoc = m_pMdtVTree->GetFirstDocPosition();
	if(posDoc)
	{
		pDoc = (CVfTestDoc*) m_pMdtVTree->GetNextDoc(posDoc);
		POSITION posView = pDoc->GetFirstViewPosition();
		CView* pView = (CView*) pDoc->GetNextView(posView);
		pView->GetParentFrame()->ActivateFrame(SW_RESTORE);	// Activate View
		return;
	}

	// Make a new window
	pDoc = (CVfTestDoc*) m_pMdtVTree->OpenDocumentFile(NULL);
	pDoc->SetTitle(_T("Tree Example"));
}

void CVfTestApp::OnExamplesPict() 
{
	CVfTestDoc *pDoc;

	POSITION posDoc = m_pMdtPicture->GetFirstDocPosition();
	if(posDoc)
	{
		pDoc = (CVfTestDoc*) m_pMdtPicture->GetNextDoc(posDoc);
		POSITION posView = pDoc->GetFirstViewPosition();
		CView* pView = (CView*) pDoc->GetNextView(posView);
		pView->GetParentFrame()->ActivateFrame(SW_RESTORE);	// Activate View
		return;
	}

	// Make a new window
	pDoc = (CVfTestDoc*) m_pMdtPicture->OpenDocumentFile(NULL);
	pDoc->SetTitle(_T("Picture Controls Example"));
}
